#include "common.h"

int debug_level = 0;

void put_timeval( struct timeval *tv, char *res ) {
   sprintf( res, "%02lu:%06lu", ( tv->tv_sec % 60 ), tv->tv_usec );
}

void debug_msg( char *title ) {
   char msg[ 80 ] = "";
   struct timeval tv;
   if( debug_level < 1 ) return;
   gettimeofday( &tv, NULL );
   put_timeval( &tv, msg );
   sprintf( msg + strlen( msg ), " : %s\t: pid=%lu, tid=%lu\n",
            title, (long)getpid(), pthread_self() );
   write( STDOUT_FILENO, msg, strlen( msg ) );
}

//---------------------------------------------------------------------------------

unsigned long long rdtsc( void ) {
   unsigned long long int x;
// asm volatile ( ".byte 0x0f, 0x31" : "=A" (x) );
   asm volatile ( "rdtsc" : "=A" (x) );
   return x;
}

#define NUMB 10
unsigned calibr( int rep ) {
   uint32_t n, m, sum = 0;
   n = m = ( rep >= 0 ? NUMB : rep );
   while( n-- ) {
      uint64_t cf, cs;   
      cf = rdtsc();
      cs = rdtsc();
      sum += (uint32_t)( cs - cf );
   }
   return sum / m;
}

//---------------------------------------------------------------------------------

