#include <sys/wait.h>
#include <sched.h>
#include "common.h"

int main( int argc, char **argv, char **envp ) {
   int c, i, N = 2, nf = 0; 
   unsigned long S = 10;
#include "option.c"
   debug_msg( "main started" );
   pid_t pid;
   for( i = 0; i < N; i++ ) {
      pid = fork();
      if( pid < 0 ) {
         perror( "fork error" );
         continue;
      }
      else if ( pid > 0 ) nf++;
      else {
         unsigned long i;
         debug_msg( "child started" );
         for( i = 0; i < S; i++ ) sched_yield();
         debug_msg( "child finished" );
         exit( EXIT_SUCCESS );
      }
   }
   unsigned long long rdt = rdtsc();
   int status;
   for( i = 0; i < nf; i++ ) wait( &status );
   rdt = rdtsc() - rdt;
   debug_msg( "main finished" );
   printf( "число процессов = %d, общее число переключений = %lu,\n"
           "число процессорных тактов = %llu, тактов на переключение = %llu\n",
           nf, nf * S, rdt, rdt / ( nf * S ) );
   exit( EXIT_SUCCESS );
};

