#include "common.h"

static unsigned long S = 10000;

void* threadfunc ( void* data ) {
   unsigned long i;
   debug_msg( "child started" );
   for( i = 0; i < S; i++ ) pthread_yield();
   debug_msg( "child finished" );
   pthread_exit( NULL );
   return NULL;
};

int main( int argc, char **argv, char **envp ) {
   int c, i, N = 2, nf = 0; 
#include "option.c"
   debug_msg( "main started" );
   pthread_t *tid = (pthread_t*)calloc( sizeof( pthread_t ), N );
   for( i = 0; i < N; i++ ) {
      int status = pthread_create( tid + i, NULL, threadfunc, NULL );
      if( status != 0 ) { 
         perror( "pthread_create" );
         continue;
      }
      nf++; 
   }
   unsigned long long rdt = rdtsc();
   for( i = 0; i < nf; i++ ) 
      pthread_join( tid[ i ], NULL );
   rdt = rdtsc() - rdt;
   debug_msg( "main finished" );
   printf( "число потоков = %d, общее число переключений = %lu,\n"
           "число процессорных тактов = %llu, тактов на переключение = %llu\n",
           nf, nf * S, rdt, rdt / ( nf * S ) );
   exit( EXIT_SUCCESS );
};

